---
title: Symbol.asyncIterator
slug: Web/JavaScript/Reference/Global_Objects/Symbol/asyncIterator
tags:
  - ECMAScript 2018
  - JavaScript
  - Property
  - Reference
  - Symbol
  - asynchronous
---
<div>{{JSRef}}</div>

<p>The <code><strong>Symbol.asyncIterator</strong></code> well-known symbol specifies the default AsyncIterator for an object. If this property is set on an object, it is an async iterable and can be used in a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for-await...of">for await...of</a></code> loop.</p>

<h2 id="Description">Description</h2>

<p>The <code>Symbol.asyncIterator</code> symbol is a builtin symbol that is used to access an object's <code>@@asyncIterator</code> method. In order for an object to be async iterable, it must have a <code>Symbol.asyncIterator</code> key.</p>

<p>{{js_property_attributes(0,0,0)}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="User-defined_Async_Iterables">User-defined Async Iterables</h3>

<p>You can define your own async iterable by setting the <code>[Symbol.asyncIterator]</code> property on an object. </p>

<pre class="brush: js">const myAsyncIterable = {
    async* [Symbol.asyncIterator]() {
        yield "hello";
        yield "async";
        yield "iteration!";
    }
};

(async () =&gt; {
    for await (const x of myAsyncIterable) {
        console.log(x);
        // expected output:
        //    "hello"
        //    "async"
        //    "iteration!"
    }
})();
</pre>

<p>When creating an API, remember that async iterables are designed to represent something <em>iterable</em> — like a stream of data or a list —, not to completely replace callbacks and events in most situations.</p>

<h3 id="Built-in_Async_Iterables">Built-in Async Iterables</h3>

<p>There are currently no built-in JavaScript objects that have the <code>[Symbol.asyncIterator]</code> key set by default. However, WHATWG Streams are set to be the first built-in object to be async iterable, with <code>[Symbol.asyncIterator]</code> recently landing in the spec.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.asynciterator', 'Symbol.asyncIterator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{compat("javascript.builtins.Symbol.asyncIterator")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols">Iteration protocols</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for-await...of">for await... of</a></li>
</ul>
